from ..form import Form
from colander import Schema, SchemaNode, String
import gocept.testing.assertion
import pyramid.testing
import unittest


class DummySchema(Schema):

    foo = SchemaNode(String())


class DummyContext(object):

    @property
    def foo(self):
        return

    @foo.setter  # NOQA
    def foo(self, value):
        raise AssertionError('error setting foo')


class DummyForm(Form):

    buttons = ('submit',)

    schema = DummySchema()

    def submit_success(self, appstruct):
        self.appstruct = appstruct
        self.apply_appstruct(DummyContext())


class FormTest(unittest.TestCase, gocept.testing.assertion.Ellipsis):
    """Testing ..form.Form."""

    def test_validation_error_is_displayed_if_data_cannot_be_stored(self):
        form = DummyForm(pyramid.testing.DummyRequest(
            post={'foo': 'foo', 'submit': 'submit'}))
        self.assertEllipsis("""...
            <span class="help-inline">
              <span
                  class="error" id="error-deformField1">
                error setting foo
              </span>
            </span>
            ...""", form().text)
