from sqlalchemy import Column, String, Integer, ForeignKey, Boolean
from sqlalchemy.orm import relation
import gocept.directory2.db


class Rack(gocept.directory2.db.Object):

    __tablename__ = 'racks'

    name = Column(String)
    max_units = Column(Integer)

    location_id = Column(Integer, ForeignKey('locations.id'), nullable=False)
    location = relation('Location', backref='racks')


class RackUnit(gocept.directory2.db.Object):

    __tablename__ = 'rackunits'

    rack_id = Column(Integer, ForeignKey('racks.id'), nullable=False)
    rack = relation('Rack', backref='units')

    unit = Column(Integer)
    comment = Column(String)
    reserved = Column(Boolean)
