from ..application import ApplicationFactory
from pyramid.paster import get_appsettings, setup_logging
import gocept.directory2.db
import os
import sys
import transaction
import zope.component


def usage(argv):
    cmd = os.path.basename(argv[0])
    print('usage: %s <config_uri> <username> '
          '<firstname> <lastname> <password>\n'
          '(example: "%s admin.ini karlheinz '
          'Karl Heinz petra23")' % (cmd, cmd))
    sys.exit(1)


def main(argv=sys.argv):
    if len(argv) != 6:
        usage(argv)
    config_uri = argv[1]
    username = argv[2]
    firstname = argv[3]
    lastname = argv[4]
    password = argv[5]
    setup_logging(config_uri)
    settings = get_appsettings(config_uri)
    factory = ApplicationFactory(**settings)
    factory.configure()
    factory.setup_runtime()
    db = zope.component.getUtility(gocept.directory2.db.IDatabase)
    with transaction.manager:
        from ..user import HumanUser
        HumanUser.create(uid=username, firstname=firstname, lastname=lastname,
                         is_admin=True, password=password)
