from ..ipaddress import IPAddress
from ..network import Network
from ..vlan import VLAN, VLANClass
import gocept.directory2.testing
import netaddr
import transaction
import unittest


class IPAddressTests(unittest.TestCase):
    """Simple smoke tests for ..ipaddress.IPAddress."""

    layer = gocept.directory2.testing.BASE_APPLICATION_LAYER

    def setUp(self):
        super(IPAddressTests, self).setUp()
        fe = VLAN.query().filter(VLANClass.abbreviation == 'fe').first()
        net = Network.create(vlan=fe)
        self.ip = IPAddress.create(network=net, address='127.0.0.1')
        transaction.commit()

    def test_has_been_created(self):
        self.assertEqual('127.0.0.1', IPAddress.query().first().address)

    def test_netaddr_returns_netaddr_IPAddress(self):
        self.assertEqual(netaddr.IPAddress('127.0.0.1'), self.ip.netaddr)
